# squash_matrix_api

SquashMatrixAPI - the Ruby gem for the Squash Matrix API

# Endeavor The squash matrix API enables clubs, players, and regions to own their information, with results being updated weekly. The API information sits ontop of squash matrix australia website [https://squashmatrix.com](https://squashmatrix.com) # API Aside from the documentation provided below, there is also a `{json:api}` available and can be accessed in the same manner, with the addition of the accept header `{accept: application/vnd.api+json}`. More information about json api can be viewed on their website at [http://jsonapi.org/](http://jsonapi.org/) # Squash Matrix Scrapper There is a ruby SDK for retrieving information from [https://squashmatrix.com](https://squashmatrix.com) which can be found at https://rubygems.org/gems/squash_matrix # SDK's Please stay posted! Client sdk's for the following will be provided shortly:    - Javascript   - Java   - Ruby  # Blog Find relevent and interesting media on [wilkosz.com.au](http://wilkosz.com.au) # Contact Join this endeavor and be appart of the community [https://www.facebook.com/squashmatrixapi](https://www.facebook.com/squashmatrixapi) <hr />

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build squash_matrix_api.gemspec
```

Then either install the gem locally:

```shell
gem install ./squash_matrix_api-1.0.0.gem
```
(for development, run `gem install --dev ./squash_matrix_api-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'squash_matrix_api', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'squash_matrix_api', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'squash_matrix_api'

api_instance = SquashMatrixAPI::DefaultApi.new

opts = { 
  page: 56, # Integer | The page of clubs
  page_size: 56 # Integer | The size of page
}

begin
  #Get page of clubs
  result = api_instance.clubs_get(opts)
  p result
rescue SquashMatrixAPI::ApiError => e
  puts "Exception when calling DefaultApi->clubs_get: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://api.squashmatrix.io/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SquashMatrixAPI::DefaultApi* | [**clubs_get**](docs/DefaultApi.md#clubs_get) | **GET** /clubs | Get page of clubs
*SquashMatrixAPI::DefaultApi* | [**clubs_squash_matrix_id_get**](docs/DefaultApi.md#clubs_squash_matrix_id_get) | **GET** /clubs/{squashMatrixId} | Get club by Squash Matrix ID
*SquashMatrixAPI::DefaultApi* | [**games_game_id_get**](docs/DefaultApi.md#games_game_id_get) | **GET** /games/{gameId} | Get game by ID
*SquashMatrixAPI::DefaultApi* | [**games_get**](docs/DefaultApi.md#games_get) | **GET** /games | Get page of games
*SquashMatrixAPI::DefaultApi* | [**players_get**](docs/DefaultApi.md#players_get) | **GET** /players | Get page of players
*SquashMatrixAPI::DefaultApi* | [**players_squash_matrix_id_get**](docs/DefaultApi.md#players_squash_matrix_id_get) | **GET** /players/{squashMatrixId} | Get player by Squash Matrix ID


## Documentation for Models

 - [SquashMatrixAPI::ApiResponseErrors](docs/ApiResponseErrors.md)
 - [SquashMatrixAPI::ApiResponseErrorsErrors](docs/ApiResponseErrorsErrors.md)
 - [SquashMatrixAPI::Club](docs/Club.md)
 - [SquashMatrixAPI::Game](docs/Game.md)
 - [SquashMatrixAPI::InlineResponse200](docs/InlineResponse200.md)
 - [SquashMatrixAPI::InlineResponse2001](docs/InlineResponse2001.md)
 - [SquashMatrixAPI::InlineResponse2002](docs/InlineResponse2002.md)
 - [SquashMatrixAPI::InlineResponse2003](docs/InlineResponse2003.md)
 - [SquashMatrixAPI::InlineResponse2004](docs/InlineResponse2004.md)
 - [SquashMatrixAPI::InlineResponse2005](docs/InlineResponse2005.md)
 - [SquashMatrixAPI::Player](docs/Player.md)


## Documentation for Authorization

 All endpoints do not require authorization.

